Penfriend XP Help Contents

Penfriend XP Help

Welcome to Penfriend XP help. The following guide will provide everything you need to know to get you started with Penfriend XP.

Penfriend XP is a powerful and innovative word prediction utility that can help you type faster and accurately by predicting or guessing the correct word that you want to write. This utility is particularly useful for people who have literacy difficulties such as dyslexia. Word prediction is also useful for those who experience motor difficulties or have a physical disability which makes it difficult or impossible to type.

Penfriend XP also offers a range of powerful features such an on-screen keyboard, text-to-speech, screen reading and can be setup to support people with a visual difficulty. Penfriend XP works along-side normal word processors and other applications on Windows.

Introduction to Penfriend XP. This explains who it is for, how it works, and what to read next.

Penfriend XP's Windows. If you are looking at a particular part of the program and want to know what it does, start here.

Menu Options. If you see a menu option with an unfamiliar name, look here to find out what it means.

Preferences. Explains how you can adjust the application's behaviour to suit.

Advanced Topics. Describes installation in network environments, use with other applications, and further topics

The Small Print says who wrote this software, and gives their address in case you want to buy more copies.

Penfriend in use with a word processor


Penfriend XP Introduction

What does Penfriend XP do?

Penfriend XP is a predictive typer, and on-screen keyboard. It works with your favourite word processing software and suggests words that you have typed. For example, by typing the letter 'y' followed by 'e' will predict the word 'yesterday'. This saves people the time and helps to increase the speed and accuracy of typing.

Penfriend in use with a word processor

Word Prediction is helpful to those who don't have confidence in their ability to spell as well as those with a physical impairment which requires they cut down on keystrokes so that their typing speed can improve.

The speech feedback will help many people with dyslexia, learning difficulties, visual impairment and can be customised towards differing abilities.

The On Screen keyboard could be useful to someone with a physical impairment which makes it difficult for them to type. It reduces the visual strain of glancing between keyboard and screen for those with dyslexia and it also simplifies typing other languages.

Screen Reading can help both those with learning difficulties and many with poor eyesight.

Penfriend XP runs under Microsoft Windows 8, 7, Vista, and Windows XP, alongside your normal word processor or whatever other software you use. (It is also available for Windows 3.1, 95, 98, ME and NT and also for Acorn Risc OS). It intercepts key-strokes from your keyboard on their way to the word processor and uses them to generate its predictions, and also has an on-screen keyboard which lets you type words into other software by clicking with the mouse.

Penfriend XP can speak each letter or word as typed, and can read the Windows clipboard containing text from any application, and can even read menus and dialogue boxes from most applications.

Getting Started Tutorial

The main use of Penfriend XP is to work along-side a word processor, with the Prediction Window open.

First, you should start your word processor or similar application.

Then you should start Penfriend XP. You must not have more than one copy of Penfriend XP running.

There should be a default lexicon with 10,000 words to predict from. If you want a different lexicon such as a different vocabulary size, go to the Start Menu in the bottom left corner of your screen, choose Programs, Penfriend, Lexicons. A window should open with a choice of lexicon files; double click on any of these to load them into Penfriend XP. Note that when you save your lexicon, it will normally go to My Documents rather than the folder you are looking at now.

Click your mouse in the word processor window, so that the computer knows where you want to type. Think of a sentence you would like to write.

Now you are ready!

Type the first letter of your sentence in your word processor and then look at the prediction window. If the word you want first is there, press the function key marked by that word, or click on the word with the mouse. If your word is not on the list, type the second letter, repeating the process as necessary. If the word is never shown, type it all and Penfriend XP will learn it for next time.

Temporarily stop Penfriend XP predicting words.

It is also possible to stop Penfriend from predicting words, for example, if you are writing a 'www' address of a website or you simply want to type a number. To temporarily stop Penfriend XP from predicting press the minimise icon on Penfriend XL's prediction window.

Select the minimise icon to temporarily stop predicting

This will temporarily stop Penfriend XP from predicting and will default to the bottom of your computer screen. To start Penfriend XP predicting click on the Penfriend XP icon (bottom of your computer screen) and the prediction window will appear and you can continue to use word prediction.

See Also:
- Saving the Lexicon
- Learning New Words
- Personalising the settings
- Preferences Dialogue Box
- Who would use Penfriend XP
- Contents page
- Menu Options
- The Windows


Who would use Penfriend XP?

Penfriend XP is a very flexible program and can help a range of people with diverse needs.

  • people learning to write foreign languages.
  • people with literacy difficulties including dyslexia.
  • people with motor difficulties such as cerebral palsy.
  • people who have conditions such as arthritis, rheumatism or have experienced a stroke, and find it difficult or impossible to use a standard keyboard to type.
  • people who are slow at typing and simply want to increase their typing speed and accuracy.
  • people who find it difficult to read large amounts of text and prefer to listen instead.

Penfriend XP can also support people who have a visual impairment and require information in large font or a high contrast background or find it helpful to have text read to them.

Use Penfriend to support visual difficulties

Penfriend XP can be used by people of all abilities and ages!

Clearly, Penfriend XP is not intended for use with highly skilled typists, but it is helpful to people with some physical disabilities, or slow writers. Prediction has also been found to help people with poor spelling, although the writer will need to spell the first letter or two correctly in order to see a prediction.

The on-screen keyboard was originally designed for people with motor impairments, who cannot type on a normal keyboard easily. It might also be used by someone who needs very large text on screen to see, as the size of font and background can be changed easily. It can be useful for dyslexic people, because it reduces visual strain and saves them from glancing repeatedly between the keyboard and screen.

The speech facility can be used by people who prefer to hear text being spoken than to read it from the screen themselves. Because it works with any application that can put text on the Windows clipboard, or which supports Microsoft Active Accessibility, it is very versatile. The way that it highlights text as it is read helps people with moderate literacy skills.

See Also:
- Personalising it for your abilities
- Introduction


Personalising Penfriend XP

Penfriend XP has a lot of options, not all of which will be useful to any one person. For example the on-screen keyboard is quite a specific item, and having it speak all the predictions every time they change would become monotonous and for some people rather annoying.

Word prediction is theoretically useful only for people who can read all of the suggestions faster than they can type another letter. Their slowness may be due to physical problems or doubt, so a fair number of people come into this definition.

If you are physically disabled but completely confident of what you wish to write, you can customise Penfriend XP by going to 'View' and selecting 'Preferences' from the prediction window. This will open the Preferences window. Here you can:

  • Switch on Next Word Prediction,
  • Switch on Unrepeated Predictions,
  • Expand the window to show twelve words,
  • Load the largest lexicon available,
  • Ensure that it will Learn New Words,
  • You may want to use the On Screen Keyboard.

The Penfriend 'Preferences' offers a range of personalisation options.

Penfriend offers a range of features.

If the user is not confident of their writing, due to a learning difficulty such as dyslexia or a more general problem the Penfriend XP offers a number of useful options, for example, you can:

  • Load a lexicon with words that the user is familar with. Perhaps a 2000 word lexicon, or even less.
  • Make the prediction window smaller, so that the user can read every prediction without tiring.
  • Switch on Confusable Word Hints so that similar words are disambiguated.
  • If they experience scotopic sensitivity, set the window colours to be easier to read.
  • Set the font size to be large enough to read easily.
  • Switch off some of the power options described above. Predict Next Word is bad for people who are not sure what they want to write, and who might be swayed by the list offered.
  • Switch off Unrepeated Predictions, which is bad for people who cannot reliably scan the whole list each time, and so who might miss the word they want.
  • Some dyslexic users also like the on-screen keyboard because it reduces visual strain and saves them from glancing repeatedly between the keyboard and screen.

Penfriend's Lexicon can help people with literacy difficulties such as dyslexia.

Click 'View' on the Penfriend XP prediction window and select 'Lexicon' from the drop down menu.

If your literacy skills are limited (or you are reading this on behalf of such a person!):

  • You will probably not want a large lexicon. Many sizes are available and may even be created to order in some cases. It may suit very early writers to have a custom made lexicon with only a few dozen words. The default is 10,000 words. Only expert writers dealing with specialised subjects are likely to need larger lexicons, in which case they may wish to use the 'Learn Text File' option to load topic-words into their lexicon.

  • You may also like to use Clicker with Penfriend XP as it has grids with key words and pictorial symbols. Clicker 5 can be used with Penfriend to predict words on Clicker's on-screen keyboards. Clicker can be configured so that when words are predicted by Penfriend, pictures or words are also shown alongside the word, thereby providing additional support for struggling learners.

Example of Clicker keyboard/images and Penfriend

If you are a teacher supervising work by young children:

  • Use a small lexicon, eg with 500 words,
  • Before they start writing, type the text that you hope they will write yourself. This primes Penfriend XP for those words,
  • You should review the new words in the lexicon occasionally. It is easy to see the words that have been added, and to decide whether to let them stay, give them the boot, or ban them.

If you have a speaking word processor:

Penfriend can speak text on the screen

  • You may not wish Penfriend XP to speak letters and words, although speaking the predictions may continue to be useful.
  • People who are confident of their typing they should switch off 'Speak Letters'.
  • Those who use the clipboard a lot with confidence might want to switch off 'Speak Clipboard'.

People with Cerebral Palsy or Friedrich's Ataxia may like the on-screen keyboard, especially if they prefer the mouse to the real keyboard. It can be re-sized to suit almost any degree of manual dexterity. The font used in it is the same as the prediction window font so long as there is room for it. If the keyboard window is too small, the Windows Icon font is used. The colours cannot currently be changed. For people who do use the real keyboard, it is a waste of space. You may also like to use Clicker with Penfriend XP which can be controlled by switches.

If your physical disability makes you press keys inadvertently, you can switch on an Acceptance Delay (FilterKeys) from the Accessibility part of the Windows control panel.

The prediction window can have its colours changed to make reading more comfortable. Some dyslexic and other people have scotopic sensitivity which is relieved by careful choice of the colour scheme. If you wish more precise control of the colours, set your monitor to 16 or 24 bit colour by going to your Windows Control Panel for the Display.

The font used in the prediction window can be adjusted too. Many people prefer bold sans-serif fonts like Arial Bold. Choosing a bold font distinguishes the predictions from the function key labels, which will not be in bold. Do not be afraid to use large sizes if you wish, for example 100pt.

This may suit people with visual impairments. You may wish to set your word processor to a similarly large font either by zooming in or simply changing the font size. If you cannot read menus and icon captions on any programs, you may wish to change your monitor to a lower pixel resolution such as 640x480 using the Display section of your Windows Control Panel.

If you are trying to encourage a reluctant writer to put something down 'on paper', you may wish to:

  • Choose bright colours for the prediction window.
  • Add an interesting font. You can download TrueType fonts from the Internet or buy them on CDs if the ones you have are not wacky enough.
  • Some people benefit from smaller lexica although you might make it even better by adding a few choice words of your own.
  • If you have Clicker installed, you could use it to provide suggested words, part-made sentences or graphic content for documents.

    See also:
    - Preferences
    - Advanced Preferences


Windows in Penfriend XP

Prediction Window. This is the main window in Penfriend XP. It contains a list of suggestions, if there are any to be made, from which you can select words. It normally also shows the menu bar from which you can reach all other parts of the program. This should be kept visible while you are using your word processor.

On-Screen Keyboard Window. This is to help people who do not like or are unable to use the physical keyboard. Instead, they can use the mouse (or a substitute device) and click on letters to type them into the word processor. It also helps people to write in a foreign language which requires accented characters.

Speaking Clipboard. This allows you to listen, watch and control the reading of text for the speech synthesiser. It highlights each word as it is spoken from the Windows clipboard.

Preferences Dialogue Box is available from the menu in both the Prediction window and the Keyboard window. It allows you to set most of the options in Penfriend XP. These options are then saved in the lexicon file you are using.

Advanced options dialogue this is linked to the Prefences dialogue which allows setting of the less common options. Part of the 'hidden sophistication' of Penfriend XP.

Speech dialogue box is available from the Preferences dialogue box. It controls settings for the speech synthesiser which reads words and letters as you type them, amongst other things.

Lexicon Window. This lists the words which Penfriend XP knows how to spell, and thus is able to predict. From this window you can review new words, delete words, and view detailed information about word usage.

Abbreviation Window. This is similar to the Lexicon window in that it contains a list of words, except that they are automatically replaced when you type them; typically the typed version is an abbreviation or a misspelling of the replacement version.

See Also:
- Menu Options,


Prediction Window

The most important operation of Penfriend XP is to suggest words that you may be in the process of typing, to save you the effort of pressing the remaining letters. To do this, it must tell you what its predictions are, and allow you to choose the one you want if it is on the list.

The Prediction window normally appears when you load Penfriend XP. It begins with the name 'Penfriend XP' and a version number. As you press letters on the keyboard it changes its predictions to the best guess it can. If you wish to accept one of the words, press the function key indicated beside the word of your choice. You can also click the mouse over the word of your choice, if you prefer. The remainder of the word will be sent from Penfriend XP to the target window (the word processor you were using).

Penfriend in use with a word processor

Prediction Window layout

Penfriend's Prediction Window offers a variety of styles to view predicted words, for example, in a vertical column (similar to the illustration above) and as a horizontal row, similar to the illustration below.

The default Prediction Window is a vertical column but if you prefer to use a horizontal style you can change this in the Preferences panel - 'View', 'Preferences', 'Style' and select 'Horizontal' from the drop down menu.

Changing Colours, Fonts and Styles

As well as the Horizontal option you can choose from 3 other Styles, i.e., Plain, Grey and Round. Round is the default option when you start Penfriend.

Penfriend colour style prediction Penfriend colour preferences

You can change the colours and fonts used in the prediction window by changing the preferences on the View Menu. If you choose a bold font for the predicted words, the function key labels will not be in bold. This helps to distinguish them quickly from the words.

Sort Predictions Alphabetically

Predictions can be sorted so they are displayed in alphabetical order. This display also has the function keys greyed out so that the prediction is easier to recognise.

You can change the prediction style to alphabetical order in the Preferences panel - 'View', Preferences' and select 'Sort predictions alphabetically'.

Saving Lexicons

At the top of the prediction window there is a File menu bar. The drop down menu on the File menu bar allows you to load or save a lexicon file, and to open all of the other windows for the program.

Save or open lexicon from the File meno

If you have closed the Prediction Window you can reopen it by choosing 'Predictions' from the 'View' menu of any of the other windows.

You may change the number of words in the prediction window simply by resizing the window. Drag the bottom edge down and you will reveal up to twelve words. You should adjust this to suit the user; too many words will take a long time to read, but too few will prevent likely predictions from appearing.

If a word is predicted which you think should not be in the lexicon, or you think it is not relevant in this situation, you can view the detailed word properties by holding down the Alt key and clicking on the word (or by finding the word in the lexicon window).

See Also:
- Function Key Interception
- Menu Options
- Preferences


On Screen Keyboard

The on screen keyboard allows people who do not wish to use the keyboard to write by clicking on a graphical representation of the keyboard with their mouse, or mouse substitute. You can open the Keyboard window from the 'View' menu in any window.

The On-Screen Keybarod is launched from the View menu.

If you wish to write a capital letter, click the mouse on either of the Shift keys in the on-screen keyboard. This will change the labels on all of the other keys to show what they would actually type if clicked on (that is to say, the key labels for letters will become capitals). When you then click on one of the normal keys, the shifted version will be typed into your word processor and the Shift key will switch off. You can see when the Shift key is switched on by both the inverted colour of the Shift keys and the characters on the normal keys.

If you wish to type more than one character with Shift held down, click on the Lock key which is above the left Shift. This is equivalent to holding down Shift until you click on Lock again or one of the Shift keys. It is not a Caps Lock because it affects numbers and punctuation as well as letters. While locked, the Lock and Shift keys will all change colour.

You can re-size the on-screen keyboard to suit your vision and the size of your screen. Simply drag any of the edges, as with a normal window. When the window gets particularly small, Penfriend XP will change the font used for the key labels from your chosen font to the Windows icon font. When it is large enough, the keyboard window will use the same font as the prediction window. There is no way to change the colours of the Keyboard window at present.

Some of the keys have the same effect regardless of the Shift key, including Backspace and Return. The Control key currently has no effect. If you have any trouble getting your word processor to recognise a letter being pressed in the on-screen keyboard, please check the notes on the keyboard target window. The most likely fault is that the keyboard window has become the active window, so when you click on a letter it sends a message to itself instead of to your word processor. Please click in your word processor window to activate it.

If you want to type numbers using the onscreen keyboard set selection to function keys and then select the words by clicking on them in the predictor window and use the numbers on the onscreen keyboard.

See Also: Keyboard Target Window


Clipboard Window

The clipboard speech window is primarily concerned with speaking the contents of the Windows clipboard, which will contain text from another application. To put text on to the clipboard from your word processor, mark it with the mouse or in another way, and select copy from the edit menu. This can be done more easily in many programs by holding down Shift, pressing cursor Up or Down to mark lines of text, and then pressing Ctrl-C. Examlple of highlighted text

As it speaks, Penfriend XP highlights each word to make reading easier. The colours used for this, as with the prediction window, are normally based on the currently chosen colours in the Preferences dialogue box. If you wish to change the highlight colours, please do so in the Advanced Preferences dialogue box. The clipboard window will automatically scroll down if necessary to ensure that the current text is visible.

The Clipboard with read text aloud.

If you wish to hear an individual word from the clipboard text, please click on the Stop button at the top of the clipboard window if necessary and then click on the word you wish to hear. It will be highlighted as it is spoken. If you move from word to word too quickly the words may not be highlighted as they are spoken. To hear the text starting from that point, click on the word with the right hand mouse button.

To hear the entire clipboard text, click on the Play button (a green triangle) in the toolbar at the top of the clipboard speech window. To completely stop the speech, if you do not wish to hear the remainder, click on the Stop button (a square).

Penfriend XP is configured by default to speak text as it is copied to the clipboard, so simply pressing Ctrl-C will trigger the speech. You can control this on the speech options dialogue box. Once it is speaking you may stop it as described above.

If Penfriend XP is set to speak the clipboard automatically, and the clipboard window is closed, then it will be opened for the duration of the speech only; after it has finished, the window will close itself again. If you open the window by choosing 'Clipboard' from the menu of another Penfriend XP window, it will stay open.

The voice speed and pitch are controlled in the speech options dialogue box which can be found from the main Preferences dialogue box. If you do not wish Penfriend XP to speak at all, set the sound option in the preferences dialogue box either to Sound Effects or to None.


Abbreviation List Window

The Abbreviation Window lists the abbreviations that can be expanded as you type, by Penfriend XP. You can add more if you wish, or remove existing ones. The abbreviations are displayed in alphabetical order.

The Abbreviation panel on the View menu

The expansion might be your full name, your address, phrases used in letters or formal documents, or simply a word that you do not want to type in full. If you wish, you can create abbreviations which are in fact corrections of misspelt words. The abbreviation should be the misspelling (with a separate entry for each likely misspelling) and the expansion should be the correct spelling. There is no need for the latter to be longer than the former.

Creating a new abbreviation

Penfriend XP will expand the abbreviations when you type them as a word in your normal word processor, so long as the prediction window is open. The abbreviations will also be predicted if there is room in the window, so you can use them by pressing a function key or clicking on the word or finishing the abbreviation and pressing Space.

Abbreviation example with text

If you click on one of the existing abbreviations, or below the last one, the Abbreviation Dialogue Box will open allowing you to edit or create an abbreviation.

Extending Abbreviation

The Abbreviation feature can also be used to display up to 12 related expansions by typing one abbreviation. In the illustration below the abbreviation TV is used to display 12 requests to help with the TV. This could be a useful feature in a care setting or for someone who has limited or no speech.

Below is the abbreviation window where the 12 abbreviations have been created; 'tv1' corresponds to 'Please switch on the television',' tv2' corresponds to 'please swtich off the television' and so on.

Abbreviation expansion example

When the abbreviation ‘tv’ is typed into a document, the 12 instructions all appear in the predictor window. Note that tv does not appear as it has been banned in the lexicon.

Abbreviation in the prediction window

If Penfriend is set to speak on a right click then the phrase will be spoken aloud by Penfriend’s speech.

Used in this way abbreviations can be used for common phrases, email and postal addresses and more.

See Also:
- Abbreviation dialogue box


Lexicon List Window

When a lexicon is loaded, it is displayed in the lexicon window. If a word has been added recently to the lexicon, it will be shown in red with the word "new" after it. They are marked like that to help you spot them and decide if you wish to keep them in the lexicon. To make it even easier to find them, you can remove all of the 'Old' words from the display using the 'Show' menu options, such as 'New Words'. To turn a new word into an old word, you must 'Accept' it into the lexicon. Alternatively you can delete a word, either new or old, from the lexicon to stop it being suggested.

New lexicon with new words shown in red

To accept, ban or delete a word, point at it in the lexicon list (in the lexicon window) and press the right hand mouse button. The Lexicon context menu will appear from which you can Approve it, to turn it from red to black and thus into an old word, or Delete it, removing it from the lexicon. If it is already an old word, you can Disapprove it, thus converting it back to a new word.

Deleting a word from the lexicon

Instead of deleting a word you may want to ban it and so prevent it from being predicted. This is useful for mistakes which the user frequently makes. Simply deleting the word would mean that the next time they use the word it will be learnt again, whereas marking it as never being predicted means that the system knows the word but will not use it. This option is available from the right-button menu. This is also valuable if you want to prevent simple words being predicted. You may also approve or delete all of the new words from the lexicon context menu.

The menu at the top of the lexicon window allows you to open other windows in Penfriend XP if you wish, or to load and save lexicon files.

If you wish to edit the lexicon, you may find it useful to display only the new words which have not been approved. To do this, switch to New words on the Show menu.

If you click on a word in the lexicon window with the left (normal) mouse button, you will see the word detail dialogue box.

See also:
- Learning New Words
- Lexicon Context Menu
- Word Detail Dialogue Box


Speech Options dialogue box

Penfriend XP can work with any SAPI5 speech synthesiser. You may already have one on your computer. This can be used to pronounce words as you type them, and to help you choose which word on the list is the one that you want. SAPI stands for 'Speech Application Programming Interface' and it is the application that allows Windows to convert text to speech. We would recommend that you use SAPI5 voices as they offer a better quality speech.

Speech Options offers a range of features, such as voice selection, speak letters, word, clipboard etc.

Speech Optons panel

If you are working in a language other than English, you may be able to download an additional voices to make it sound more natural. Such voices are not provided by Penfriend Ltd.

There are a number of options which you can adjust to make the speech more pleasant to listen to. The first of these is the voice name itself; you may see a list including Microsoft Mike, Microsoft Mary, Sam, or others. You may have several speech synthesisers installed on your computer which can be used.

If you are using Penfriend Portable, you may see voices listed which are not available from other applications. These are only on the USB drive, and are not fully installed on your computer.

The speed at which the voice speaks can be controlled quite separately from the pitch. The more experienced you are as a listener, the higher speed you will be able to tolerate.

You may opt to have Penfriend speak the clipboard each time it changes. This allows you to speak text from your word processor easily and quickly. This is discussed further in the clipboard window section.

You may also choose what is spoken automatically by Penfriend. This allows you to set it to speak enough to provide spoken assistance when needed, but not so much that it annoys the user. Most of the options are self-evident from their names.

Speak Letters makes Penfriend speak each individual letter as you type it. This is useful for people who are in the early stages of literacy as reinforcement and to help construct pronunciations.

Speak Words makes Penfriend speak whole words when you have completed them. This refers to either words that you have typed yourself or ones that have been chosen from the list of predictions.

Speak Sentences attempts to remember the whole sentence that you have written and to speak it when you reach a terminating punctuation mark such as a full stop, question mark or exclamation mark. It does not have priviledged access to your word processor so if you move the cursor keys around during the sentence it is likely to become confused.

Letter Phonics can be used with Speak Letters. Instead of saying the proper name of each letter (which sound like aee, bee, sea, dee, ee, eff), it will say their simple phonic version, like ah, beh, keh, deh, eh, feh). This feature works only with SAPI5, and is not compatible with all speech engines. If you do not hear letters being spoken, please switch this off.

Speak Clipboard was discussed above. It makes Penfriend speak a block of text as soon as you copy it to the clipboard in your word processor, so you can typically speak paragraphs by marking them and pressing Ctrl-C.

Predictions allows you to choose one of a number of ways of speaking the predictions in the prediction window. The default is that they are never spoken automatically, and that you must point at a word to hear it.

Predictions: Dwell (hover) will make Penfriend speak a word from the prediction list if you have been pointing at it for more than half a second. This may be useful for people, especially mouse users, who dither over words being unsure which one is correct. It requires no commitment to begin the speaking (useful for people who are afraid of clicking).

Predictions: Immediate point will make Penfriend speak each word in the prediction list when you point at it. If you move down the list then you are likely to cut off the previous word when you begin pointing at the new one, and this may be disconcerting. It is faster, however.

Predictions: First automatically will make Penfriend speak the first prediction as soon as it changes. This, and the following options, can clash with 'Speak Words'. It has the advantage of reading out a word that you can see on screen without having to move your hand to the mouse.

Predictions: First two automatically will, like the above option, speak predicted words after each key press. Unsurprisingly, it speaks the first two words instead of the top one only.

Predictions: First three automatically does something so secret, it cannot be discussed here without your signature in triplicate on a commercial confidentiality agreement.

Predictions: All automatically is a devastatingly efficient way of disrupting a classroom, if you have big loudspeakers turned up full. It only reads the items visible on screen, so be sure to pull the prediction window out to show all twelve items.


Menu Options

Most of the interesting features are controlled from the menu which appears at the top of most of the windows.

File Menu Options: The File menu mainly affects the lexicon files in a general sense. The options are very similar to those you would find on any other program.

View Menu Options: The View menu allows you to open and close important windows which perform the main functions of Penfriend.

Lexicon Pop-up Menu Options: If you press the right hand mouse button while pointing at a word in the Lexicon Window, a small menu will appear allowing you to edit the lexicon. A similar but shorter menu operates in the Abbreviation window.


View menu

The View menu allows you to open and close the main windows of Penfriend XP.

Predictor will open the Prediction window in a prominent place, and ensures it will be permanently at the front.

Keyboard will open the on-screen keyboard window in a prominent place, and at the front.

Lexicon will open the Lexicon Window from where you can view and edit the words in the lexicon.

Abbreviations will open the Abbreviations Window from where you can view and edit the abbreviations to be expanded.

Clipboard will open the Speaking Clipboard Window which affects the speaking of the clipboard text.

Web Site will open your web browser to show the Penfriend web site. This will send enough information to identify you as a valid owner of a copy of the software, and to allow you access to privileged areas of the web site.

About will display the splash-window also shown when Penfriend XP is loaded. This indicates the exact version of the program, which is useful if contacting Penfriend Ltd for support.

Preferences opens the Preferences dialogue box which allows you to control the active features of Penfriend XP, explained on a separate page.

Help will open this help document.

See Also:
- General Menus


File menu

See Also: Control Window Menus , Saving the Lexicon

The File menu mainly affects the lexicon files in a general sense. The options are very similar to those you would find on any other program.

Open... will load a new lexicon file into memory to allow Penfriend XP to predict words from it. It will also load the preferences from that file. It is suggested that you have one lexicon file per user, although you may prefer one per topic or some other scheme.

Save will save the lexicon under the same name that it was loaded from, but will not overwrite a default lexicon, which is read-only. This is implicitly done when you quit Penfriend XP with the Save on Exit preference turned on. However, you may wish to do this at any time, for example to protect yourself against losing information if the machine crashes. Another use for this option is to save the window positions and preferences in a carefully arranged pattern, should you wish them to restart the same way.

Save As... will allow you to save the lexicon under a new file name. This may be useful for making backup copies or for duplicating files before modifying one copy. It is essential after loading one of the supplied default lexicons, because you cannot alter them and Penfriend XP will not work effectively unless it saves your lexicon each time.

Learn Text File is equivalent to typing all of the words from a file on disk. This means that the lexicon will be updated to include all of the new words, and to update their frequency information accordingly. This option is available only on the file menu of the lexicon window. More details.

Exit will stop Penfriend XP running. It saves the lexicon if the preference for Save On Exit is switched on, then removes itself from memory, closes all its windows and of course stops predicting. You can also exit Penfriend XP by closing all of the windows, but selecting this menu option can be more useful if you wish to save the window positions carefully. It is most useful if you wish both the prediction and Keyboard windows to open the next time Penfriend XP is loaded.


Lexicon context menu

The lexicon context menu can be found by opening the Lexicon Window, pointing at a word in the lexicon list which is of interest, and pressing the right-hand mouse button. The menu relates specifically to the word that you were pointing at when you pressed the button.

After a number of new words have been added to the lexicon, you may wish to check and delete them. Each new word added by the user (when they simply type a word not recognised, and when the Learn New Words preference is switched on) is marked in red as being a New Word, and as such may be prevented from prediction (with the Predict New Words option). You can change it from being New with the Approve word from this menu. It then becomes a normal word in the lexicon.

Alternatively, you may not like a new word which has been added; This would most probably be because it is wrongly spelt. In that case you can delete a word from the dictionary (regardless of whether it is a new word or not) by selecting Delete word from this menu. If you wish to add a word instead, please ensure that the system is willing to learn new words, then type it in another program preceded and followed by spaces.

Deleting a word from the lexicon context menu

You may also mark words never to be predicted. This is helpful if the user frequently makes the same spelling mistake. Simply removing the word from the lexicon would allow Penfriend to learn the word again in the future, but 'Never Predict' will ensure that it is never predicted even if they do type it repeatedly.

You may also prevent words ever being predicted by banning them. This is helpful if the user frequently makes the same spelling mistake. Simply removing the word from the lexicon would allow Penfriend to learn the word again in the future, but 'Banning' will ensure that it is never predicted even if they do type it repeatedly.

You can prevent prediction of words shorter than a certain length, and prevent prediction of newly learnt words, using the preferences dialogue box.

To view and edit the seriously detailed information that Penfriend stores about words, you may choose 'Properties' from the menu which leads to the word detail dialogue box.

See Also:
- Control Window Menus
- Preferences dialogue box


Preferences Dialogue Box

There are a number of features of Penfriend XP which you can change to suit your preferences. These include the appearance of how Penfriend looks and behaves with its prediction, lexicons, speech, and other aspects of its operation.

Preferences dialogue box

The option Learn New Words decides whether words which are typed in full, having not been recognised, are added to the lexicon or ignored. If they are added, they will be shown in red in the lexicon window until you approve them using the menu on the right hand mouse button in the control window. Penfriend XP will not learn words less than 3 letters long, nor any words containing characters other than letters and apostrophe (') or hyphen (-). If you wish to teach Penfriend XP many words, you may want to import a text file or learn from the clipboard of another application.

Please read the section on learning new words to ensure that you understand how important new words are to Penfriend XP. For a discussion of the applicability of all of the options of Penfriend XP to people with particular needs, you may wish to read about personal settings.

Smart Punctuation makes Penfriend XP move punctuation marks around a little. If you type a word followed by a single space followed by any of the appropriate punctuation marks . , ? ! ; : ' ] ) } then Penfriend XP will delete the punctuation mark and space and retype them in the opposite order. It will also switch on the latched Shift key in the on-screen keyboard if the punctuation mark was one that ends a sentence.

The option Predict Next Word makes Penfriend XP predict whole words that you have not typed any letters of. The predictions are made on the basis of grammar and recency. The feature speeds up typing but has the disadvantage of leading some writers astray, for example encouraging them to press F1 all the time!

The option Predict new words can be switched off for people who type a lot of spelling mistakes but are writing about an unusual topic. Penfriend XP will gather the words that they write into its lexicon as 'new' words, but will not suggest them until they have been accepted from the 'new' set to the 'old' part of the lexicon.

The option Unrepeated Predictions, like 'Predict Next Word', is a power-feature for confident writers who want the fastest predictions and know what they want. It makes words appear only once in predicting any particular word even if they match the letters typed. For example, if you type 't' you will be presented with words like 'the', 'this', 'they' etc. If you now type 'h', most of the same words would normally remain. With Unrepeated Predictions, all the words shown the first time will not be repeated, so a new list of words will appear.

Unrepeated Predictions has no effect on the predictions after you have finished a word. It is dangerous because some users might not notice words the first time they appear and will be disappointed when, after perhaps three letters, the word has still not appeared. It is good for people who can be sure of spotting the word they want the first time it appears. See the section on personalising Penfriend XP for more details.

The option Follow Caret defines whether the Prediction Window will move along just to the right of the text caret as you type. This can make it easier to see the predictions without moving your eyes as far, but it will obscure part of your document. If selected, you cannot change the relative position between the caret and the window. This feature is not compatible with some word processors because of the way they indicate their caret position.

Normally you select words from the prediction window by pressing the Function Key indicated to the left of the word. If you wish, you may choose to select words using the Number Keys. If so, you must use the numbers above the letters on a normal keyboard to select words. If you wish to type actual digits into a document, please use the numbers on the numeric keypad to the right of the main keyboard. While predictions are visible, you cannot type the relevant keys (function keys or numbers) into your word processor. You can also select using numbers on the numeric keypad

If you have chosen to select words using the number keys, only the numbers above the letters can be used and not the numeric keypad to the right of the main keyboard. The numbers above the letters are intercepted as described above and that interception can be briefly cancelled by pressing Escape. However, to type digits no extra keys need be pressed; simply type your numbers on the numeric keypad.

If you choose the numeric keypad, the opposite applies; select words by pressing number keys on the keypad on the right of your keyboard, and insert actual digits by pressing the keys above the letters.

If you are using the on-screen keyboard, it is probably best to choose 'Function Keys' but to actually select the words by clicking on them directly with the mouse in the prediction window. You can then enter numbers using the digits on the on-screen keyboard.

The words in the prediction window are normally sorted by probability, so the most likely word is at the top of the list. However, if you prefer, Penfriend XP can Sort Predictions Alphabetically so that the same words will be on the list (chosen by probability) but within those displayed, they will be sorted alphabetically.

Please read the section about personalising the options for advice on which options to set according to your abilities.

You may wish to hear a text to Speech synthesiser speak each letter as you type it, and each word as you finish it. This requires a sound card to be connected properly to the computer, and a SAPI4 or SAPI5 speech engine to be available in software. There are a number of options for the speech system which can be adjusted in the Speech Options dialogue box.

You can choose your font size and colour for the prediction window. This setting is also used in the on-screen keyboard and clipboard window. Some people prefer particular colour schemes, and of course, the size can be chosen to balance readability with use of screen space.

The Style of layout affects the colouring and distinction between each entry on the list. The more complex colouring may seem more attractive and easier to distinguish, or it may be confusing to some users.

  • Plain: The predicted words are shown in a single colour with a single coloured background.
  • Grey: The label indicating which function key or number to press, is shown in a slightly different colour to make the word itself easier to distinguish.
  • Round:The background colour of the prediction window behind the text, is shaded as if curved, to make it easier to distinguish lines of text.
    • Horizontal
  • Horizontal: All predictions are shown side by side, rather than being stacked vertically. This requires a very wide prediction window, but it does not need to be high.

If you are an experienced computer user and you require finer control of Penfriend XP, you may wish to view and change the Advanced Preferences dialogue box. Some further ordinary preferences are available there.

See Also:
- Advanced Preferences,
- Speech Preferences,
- Personalising the Options.


Advanced Dialogue Box

There are a number of features of Penfriend XP which you can change to suit your preferences but which you are less likely to want to modify. These include the way Penfriend XP communicates with other programs, and secondary aspects of the appearance of the windows.

Advanced Dialogue box

The option Slow automatic Typing refers to the communication between Penfriend XP and your word processor when you choose a prediction from the list, or type a punctuation mark with Smart Punctuation switched on. If you find the last few letters of long predictions being missed out, or smart-punctuation not working properly, you should switch Slow Typing on and try again.

When you launch Penfriend XP for use, it normally loads the same lexicon file it was using the last time you quit it (for the same Windows user). This is intended to make it easy to keep a personal lexicon. However, if you have several people using the same computer as the same username, or not in Windows NT (etc), this may be unhelpful. In that case, switch off the 'Load Previous Lexicon' option to prevent any lexicon from being loaded at start-up time.

The next time the program is loaded a message will appear in the prediction window saying that there is no lexicon, and clicking in that window will bring up the 'open default lexicon file' dialogue box (there should be an option on the left to go to My Documents, where personal
lexicons are stored).

No speech in server mode disables the text-to-speech and screen-reading features, when Penfriend is used with another application such as Clicker 5

The option Save on Exit lets you choose whether the lexicon will be updated automatically with words that you have used or not. It is recommended that you keep this feature switched on. If it is on, the lexicon including new words that you have taught the system (simply by using them) and changes in the relative frequencies of words used (again, observed from their being typed) are recorded when you quit Penfriend XP. If not, you must explicitly save the lexicon from the menu.

It is important that you quit Penfriend XP properly instead of simply switching off your machine. The best way is to choose 'Exit' from the 'File' menu in the control window or from the system menu of most of the other windows.

When reading back from the Clipboard, typing with the keyboard or viewing the predictor window you may want to control the colour and intensity of the highlighting. If so switch off automatic highlighting and adjust the colours to your liking.

You can control the line spacing between words in the prediction window with the line spacing option. This should normally be 120, meaning that between each line of text there is a gap of 20% of the font size. If you wish the words to be more widely spaced, increase this value. A value of less than 100 is probably not useful, although it may help to save screen space.

If you are visually impaired and using a large font you can also use this large font on the keyboard. To do this switch on Use main font in Keyboard window. With a large font you will need to make the keyboard larger by dragging one of the corners.

Allow mouse clicks in other windows helps Penfriend XP to continue predicting text while you are using the mouse. If you use another on-screen keyboard (apart from Penfriend XP's), then Penfriend XP would normally consider each click in it to be a change of writing context, and would therefore cancel any predicted words. This would not help you to write. This option is most useful with Clicker.

Learn First Word after Mouse Click is suitable for people clicking with their mouse a lot compared to the speed of their writing. Normally, Penfriend XP would not learn the first word written after a mouse click, in case it was a partial word and the click had been to move the cursor. If the first word was important, it would be wasted. This option tends towards assuming that people write whole words rather than partial words.

Don't predict words shorter than 0 disables prediction of short words, which may give a small benefit in keystroke savings and which may fill up the prediction lists, thereby reducing effectiveness.

See also:
- Personalised Settings.
- Main Preferences.


Abbreviation Dialogue Box

You are probably looking at the Abbreviation editing dialogue box for one abbreviation.

The dialogue box that appears allows you to enter the abbreviation, that is the text that you are going to type on the keyboard, and the expansion, that is the text that will be used instead. For example, in the above illustration the abbreviation 'pfcontact' is used to expand Penfriend's contact details. This is an excellent feature to help minimise keystrokes and repetitive tasks.

Text to input with abbrevaition

The abbreviation should be a short sequence of letters or numbers, but should not include spaces or punctuation. The expansion can include any normal characters.

See Also:
- Abbreviation list window which includes information on expanding the use of abbreviations.


Word Detail Dialogue Box

Penfriend XP stores a lot of information about each word that it uses, and this is available for inspection in this dialogue box. It can be seen by choosing Properties from the lexicon window pop-up menu or by holding down the Alt key and clicking on the word when it appears in the normal prediction window.

Word properties dialogue box

The spelling may contain capital or lower-case letters (normally lower case), and accented characters.

The word frequency indicates the number of times the word has been observed so far. This includes a default 'factory' setting from the lexicons as they are delivered to you, and is updated each time the word is used.

The 'recency' number rises when you use the word, and drops off when you do not. This may be around 100 for common words. Modifying it will have only a short-term effect.

If the word is marked as being 'new', it will appear in the new section of the lexicon list window, and will be more actively modified in usage. Please see the discussion on learning new words.

If the 'capitalise' option is on, the word will be predicted exactly as it appears in the lexicon. This is intended for proper nouns. A lower case word with this option set will be predicted with entirely lower case letters, even if you typed a capital.

The option 'never predict' allows a word to be in the lexicon but never used. This is most suitable for common spelling mistakes.

The list of following words indicates a few words which are likely to come after this word. You may move words up and down this list by selecting one and pressing the up or down cursor (arrow) keys. You may also delete entries. To add an entry, type the words in your normal word processor. The list will always be updated to include the word that followed this one the last time it was used, and may or may not include different words used earlier.

You may delete the entire word from the lexicon by clicking on the 'delete' button, or update your changes by clicking on 'OK'. If you make changes, please ensure that the lexicon is saved either by hand or automatically at the end of the session.


Saving the Lexicon

It is normal to save the lexicon at the end of each session (as long as you are not using the Default lexicons which are Read Only), so that the new words and word frequencies the computer has learnt will be available for the next time you use it. The lexicon file saved contains not only the words known but statistical information about their usage and also your preferences for the use of Penfriend XP, such as the position of the windows and whether the system should learn new words.

The lexicon is normally saved automatically at the end of each session with Penfriend XP as long as you have first saved the default lexicon under a new name; this is controlled by the Save on Exit option in the Advanced Preferences dialogue box.

Save on exit

If this is switched on, you need not worry about saving. If it is switched off, you should go to the File menu in any window and select File > Save or File > Save As... from the menu. This has the advantage of letting you control the saved window positions more accurately.

When you exit from Penfriend XP it will note the name of the lexicon that you were using. When you restart Penfriend XP, it will look for the previous lexicon, and restore all of the settings including window positions to the state they were in when the lexicon was saved. The name of the last lexicon is recorded in the Windows Registry for each login user of the computer.

You can save the lexicon under the existing name using the menu option File - Save or you can choose a new name using File - Save As... . Either way, Penfriend XP will attempt to reload the same file when it is next loaded.

It is recommended that you have one lexicon per user, although you may prefer to have one per topic of writing, or to follow another scheme of your own choice. The lexicon directory section explains this in more detail.

Note that if you close all of the windows, the lexicon will remember that only the last one open (from the choice of the Prediction window and On-screen Keyboard window) will be opened the next time you use Penfriend XP. If you use both, this can be a bit disconcerting.

See Also:

  • Lexicon Directories
  • Save Read-Only Lexicons


Learning New Words

See also:
- Lexicon Window ,
- Importing Text Files,
Learning from the Clipboard.

Penfriend XP is supplied as standard with quite a small set of words, so as not to confuse people who are not familiar with rarer words. This is intentional, but it means that it will almost certainly not have all the words that you want in it. Of course Penfriend XP is quite happy to learn new words, and you can review the list of new and old words, removing or adding entries as you please.

To learn a new word, make sure Penfriend XP is running, go to your word processor and simply type the word. When you press the space bar at the end of the word, Penfriend XP will learn it and will immediately be ready to predict the word should it think you are about to type it. (Assuming the preferences are set appropriately)

Learn new words

If you wish to use a word which is similar to an existing one, you can type the first few letters until the similar one is predicted and choose it. Then, delete the space after the word (and some letters if you wish) and type the new ending. This is often faster than typing the whole new word.

Penfriend XP stores all of its words in a lexicon, and it can only load one lexicon at a time. There are, however, two aspects to the words in the list; some are marked as being new and others are not. You can see the entire lexicon in the lexicon window by choosing 'lexicon' from the 'View' menu of the prediction window. In there, you can choose whether you wish to see all words, or just the new ones, or just the old ones, by selecting the menu options in the 'View' menu.

You should only use the default lexicon to start off. Load it and then save it under a different name, for example the name of the person who will use it. The filename should end in '.lex' to identify the file type. When you save it, Penfriend XP will remember the name and re-load it next time you start it up. It will also reload all the other preferences for that user such as special colours, window positions, font sizes etc. The default lexicons are Read only and cannot be modified and thus cannot be corrupted. It allows you to use Penfriend XP with several users easily.

On a network, having personal lexicons is essential because anyone saving a file will overwrite the previous contents of it; this means that if many people work with the same lexicon and then each saves it, only the last person's words will be kept.

It is wise for a teacher, parent, or other good speller to view the list of new words occasionally, perhaps once a week (depending on their tendency to use incorrect words). All of the newly added words can be seen in red, and are all clearly listed together with appropriate choices from the View menu.

Any words from the lexicon, including both old and new ones, can be deleted if you think that they are not appropriate. To do this, point at the word, press the right hand mouse button and select Delete word from the context menu. The menu option will actually be 'Delete' followed by the word that you are pointing at.

Similarly, new words can be accepted into the main lexicon of 'old' words by choosing Approve from the pop-up menu shown by pressing the right hand mouse button while pointing at the word in question.

If the user, perhaps a poor speller, repeatedly makes the same spelling mistakes then you will find that the misspellings repeatedly appear as 'new words'. To prevent this, you can 'ban' them by choosing the appropriate option from the pop-up menu or the word properties dialogue box.

More complicated information about a word, such as its frequency and the words which are likely to follow it, can be seen and changed in the Properties dialogue box which is visible from the same pop-up menu in the lexicon window, or by holding down Alt and clicking on a word when it is predicted in the normal prediction window.

If you have many words that you wish to add to the lexicon, you can either type them all in your word processor (there is no need to stop to look at the lexicon each time), or more usefully if you have the words already in a text file on disk then you can import the text file by selecting the appropriate menu option in the Lexicon window, or by dragging a text file to the Lexicon window.

Penfriend XP works by learning the vocabulary and style of the person using it. It does not pick things up immediately, so this process of adding and removing words should be considered a natural part of using it. It should be easy for an experienced speller to review the lists of words quickly, and doing so will help the normal user in a way that an automatic spelling list could not.


Learning Text Files

See Also: Control Window Menus , Approving New Words, Learn from Clipboard

If you have a file on disk which already contains words that you wish to have in a lexicon, you can ask Penfriend XP to read the file itself. This will quickly add all of the words to its lexicon and update the frequencies. This may be particularly useful for new users who have used other software before, or for a person who is about to write about a topic requiring special words that you have on file.

To learn the words in a file, go to the Lexicon Window and choose File - Learn Text File from the menu. You will be prompted for a file name to learn from. The actual procedure normally takes only a fraction of a second.

You may also drag a file from the File Manager or an Explorer window to the Lexicon window. In fact, you may drag a set of files if you wish them all to be learnt together.

Once the file(s) have been learnt, the new words will be marked as new in the lexicon. It may be prudent to check genuinely new words before importing text, then to quickly scan the list of new words in the lexicon window and accept them all from the pop-up menu.

If you find that not all the words have been learnt, it may be because an internal limit has been set to the number of words that Penfriend XP can learn in one session. Please save your lexicon, quit Penfriend XP, reload the lexicon and learn the file again. The limit is probably 1000 words more than there were when the lexicon was loaded.

If you want to develop your own lexicon from scratch, without any previous words, you can switch off the advanced preference called "Load Previous Lexicon", then exit Penfriend XP and reload it. You will now see the message "Click Here" in the lexicon window, and no words will be predicted as you type (but they will be learned). This is now a good time to import or type very controlled text of your choice.


Importing from the Clipboard

Importing text from the Clipboard.

It is also possible to learn words in text from other applications such as your web browser, using the Windows clipboard. To do this, highlight the text with your mouse in the other application's window, then press Ctrl-C or select 'Copy' from the Edit menu. To actually read the words into Penfriend, open the Lexicon window and from its menu, select 'Learn Clipboard'.

This is particularly useful if you want to learn words from a web page or part of an existing document. If you want to learn words from a whole document it may be easier to save it as a text file and learn words from that.


Lexicon Languages

Penfriend XP can predict words in English, only. To predict in other European languages, please contact Penfriend Ltd for an upgraded product.

See Also:
- Introduction
- Lexicon Directories


Approve Used Words

Penfriend XP learns new words that you write, but these may include spelling mistakes as well as proper words. One simple way of filtering out the mistakes is to approve only words which have been used more than a certain number of times.

This option, in the Lexicon Window's menu, allows you to set a number of uses, above which the 'new' words will be approved. The less common words will remain as 'new' for you to handle separately, for example by deleting them.

See Also: Lexicon Window


Save read-only lexicons

Please save your lexicon under a new file name.

It is important to save the lexicon, because it contains not just new words that you have used recently, but also information about your writing style that improves the quality of prediction, and your preferences.

If you open a lexicon which cannot be saved under the same name, normally because it is 'read only', then you should save it under a different name. Penfriend XP will then remember that and re-load the same lexicon later, unless the Load previous lexicon is switched off in the Advanced Options Dialogue box

If you have several people using this computer, each should have their own lexicon. It can be useful to have each person's lexicon saved on the desktop and the Load Previous Lexicon option switched off in the Advanced Preferences Dialogue box. Then when they click on their lexicon and start Penfriend XP they will recommence exactly where they left off and with all their own preferences.

Your preferences are automatically saved when you save your lexicon. Each lexicon can have different preferences thus a French lexicon can be saved with a French voice whereas a German lexicon would need a German voice. They can also have different colours, font sizes etc etc.

See Also:

  • Lexicon Directories
  • Saving Lexicons


Product Activation

Penfriend XP must be activated after installation otherwise it will operate with limited features, and for a limited time. Normally activation is via the Internet and is automatic if you are on-line but can also be done by telephone, on the Internet by hand, or even by letter.

Internet Activation

When you install or run the software, a dialogue box will appear requesting activation. Please ensure that your computer is connected to the Internet, and then click on OK. The process should take a few seconds and finish automatically.

Manual Activation

If you do not have Internet access from the computer running Penfriend XP, please do not try to activate the software during the installation process and click 'cancel' on the activation dialogue box. Open Penfriend XP, select 'Activate manually'. Note down the 'activation request code' which you must communicate to your supplier. There are two main ways for doing this:

  • Find another computer with Internet access, visit Penfriend Ltd's web site http://www.penfriend.biz/ and use the form to activate the software. After you enter your activation request code, an "activation response code" will be displayed.
  • If you cannot access the Internet from any computer at all, telephone your supplier and give them the activation request code.

Finally, please type the activation response code into the dialogue box in Penfriend XP on your other computer, to complete the process. It would be helpful to keep the activation response code in case you need to re-install the software, but you can ask for it again if necessary.

Once you have activated the software manually, you cannot later deactivate it by Internet.

Privacy and Confidential Information

When your software is activated, no information about other software or data files on your computer is sent. Penfriend Ltd will not pass on your information to other parties, and will not use the details for any purpose other than controlling activation and support.

Your email address is optional. If you provide it, it will help you if you wish to request support and upgrades, later. It may also be used occasionally by Penfriend Ltd to inform you of product news (no more than four times a year). It will not be passed on to other organisations.

Re-activation

If you have to re-install the software on the same computer, perhaps because of a system fault, you should be able to activate it again without problems so long as the hardware in the machine has not changed substantially.

If you have a network of computers and have purchased a site licence for Penfriend, you should be able to install each machine with the same installation code, although they will automatically change their installed codes to be unique upon activation. Each code will be linked to the others. See the page on Network Installations for more hints.

Site Licences, User Licensing and Machine Licensing

This system is based upon activating the licence on a machine (computer) rather than for a user (person). Each machine must be activated and identified uniquely.

If you have been issued a group of install codes for your site, you can use one releatedly; the system will count remaining licences automatically.

Please try running the software after installation as a typical user. This is particularly worthwhile if you use unattended batch installation across your workstations, although success with a random sample of machines should suffice. After activation, the software must record this; if your security policy restricts the ability to write program and machine data, please activate the software while logged on as an administrator.

Un-installation

This activation system is designed to allow a limited number of transfers of activation from one machine to another. Please un-install the software from the old machine first using the Add/Remove Programs control panel, and ensure that you have Internet access enabled during this process. If you uninstall the software without allowing the de-activation to be notified to the server, please re-install the software, enable Internet access and un-install it again.

If you wish to re-install Penfriend XP on the same computer, do not de-activate it when un-installing.

Moving to another computer

If you have activated by internet, remove the program whilst connected to the internet and this will deactivate it. It can then be installed on another machine using the same serial number.

Trouble-shooting and Requesting Support

If the software has been installed previously on another machine, please un-install that before proceeding.

If you have a site licence and perform unattended batch installations which do not activate automatically, please read the section above on Site Licences, or contact Penfriend Ltd for assistance.

If you have a brand new copy of the software and it does not activate, it is possible that the copy is not brand new; for example it may have been sold to another customer who installed it and returned it for a refund. If you believe this may be the case, please contact your supplier for a new copy. You will then need to un-install your first copy and re-install the second copy using the new installation code.

If your computer is replaced and you are unable to un-install the software before this, for example if it is stolen or bursts into green flames, please contact your supplier or Penfriend Ltd to explain.

If your network has a firewall or web proxy, please ensure that you allow HTTP access to the server active.penfriend.biz on port 80.

The separate section on USB pen drives describes activation and use from a USB memory stick.

If you still have trouble activating your software, please check Penfriend Ltd's web site or contact your supplier. Please be prepared to provide your name, installation code, the date and time of your attempted activation, and the history of any related installations. If you have already provided your email address, this will help in the support process.

See also:

    Network Installations


Penfriend Portable

You can buy Penfriend XP for installation on a single computer, or pre-installed on a physical device; a removable USB drive which is used as a security key and can be inserted into many computers; this is called Penfriend Portable.

When run from the USB drive, you must keep the key inserted in the computer throughout the time that you are using Penfriend. You can run Penfriend simply by inserting the key into the computer and double clicking on the Penfriend application (*.exe). There is no need to "install" the product, so you can easily work on another computer.

Please take care to exit Penfriend XP properly, and eject the USB drive, before removing it, since sudden removal may cause loss of your lexicon data.

You are welcome to use the USB drive as a memory stick for your documents and other work. Please do note delete or modify the files which are pre-installed on it (they are already marked read-only to discourage editing).

Please do not attempt to install the Penfriend executable files on your main computer. The original USB drive must be inserted for use.

After you have run Penfriend XP from the USB drive, it registers itself for opening lexicon files. If you double click on a *.lex file, it will attempt to run Penfriend XP. However, if the security key is not inserted, this will not succeed.

For further information about the security architecture, you may read the section on activation.

Permissions

The main benefit of Penfriend Portable is that it does not require activation for specific computer, and that it can work with reduced user security permissions. Specifically, these are:

  • User permission to install applications is not required.
  • Write access to HKEY_LOCAL_MACHINE is not required.
  • Write access to HKEY_CLASSES_ROOT is not strictly required, but is recommended.
  • Internet access is not required.

The following user permissions are still required:

  • Permission to read from removable USB drives.
  • Permission to execute *.exe and *.dll applications from the USB drive.
  • Permission to write to HKEY_CURRENT_USER.
  • An issue has been found on Windows Vista computers where User Account Control has been disabled, preventing use of the speech voices provided with the product. It is recommended for many reasons that UAC should be enabled.


Network Installation

Penfriend can be used on a computer network if you wish. First, you must purchase a site licence for the appropriate number of machines from Penfriend Ltd.

Unattended Installation

Penfriend is provided as an "MSI" file for Windows Installer, and can normally be installed remotely with no user interface; "unattended installation". This must be done as an administrator. On Windows Vista and beyond using UAC, it must have elevated privileges. See the UAC section.

You must specify the installation code (serial number) of your licence on the command line to MSIEXEC using the property PIDKEY. It is also recommended that you specify ACTIVATENOW=1 and provide an EMAILADDR, for example:

msiexec /qn /i "Penfriend XL.msi" /l*v penfriend-install-log.txt PIDKEY=EBEJ-EAMI-DDLL-ECOK ACTIVATENOW=1 USERNAME=Students "COMPANYNAME=Super College" "EMAILADDR=administrator@supercollege.ac.uk"

During normal installation, dialogue boxes may appear, but in unattended installation, they will not. To find out the status, you can request that msiexec generate a log file using /l*v logfile.txt as an option.

If activation fails, the installation will proceed, but the application will request activation again by the end user. If the serial number was incorrect, (fails its checksum), the application will not run and must be re-installed. If you have a group of related serial numbers, you can install on all machines with the same code.

Other properties that you can specify on the command line for msiexec include:
Property | Meaning
PIDKEY | Installation code (serial number) for this copy of Penfriend XP, which will be used for activation and for support. A serial number must be specified, and there is no default.
APPDIR | Directory on computer filing system where application will be installed. This is normally something like c:\Program Files\Penfriend\PF-XP but you can change it to any directory which will be readable by the users. If this is not specified, there is a default such as the example above.
USERNAME | The textual name of the person or role to which the installation is assigned, or who owns this copy of the product. This appears in the "about" dialogue box, and is submitted with the activation request. If this is not specified, a default is taken from your installtion of Microsoft Windows.
COMPANYNAME | The textual name of the organisation who owns or uses this product. If this is not specified, a default is taken from your installtion of Microsoft Windows.
EMAILADDR | The email address of the person installing the product. This may be needed for support enquiries in the future.
ACTIVATENOW | If this is 1 then the product will be activated during installation. This is recommended, because installation occurs with Administrator privileges. Ordinary users can activate the software but, depending on the computer, may not be able to save the confirmation. See the section on Windows UAC.
(others) | There are other properties which can be specified to standard Windows Installer packages.

Activation

The software must be activated on each machine before it can be used fully. Please read the section on site licences in the help page for activation.

You can choose whether to activate during installation, or later for each user. It is recommended that it is done during installation, which is done by an administrator. In some computer configurations, ordinary users do not have permission to write the activation confirmation and so will be asked again, later.

If you have a USB Security Key, it is not necessary to install Penfriend XP at all. Simply insert the security key in the computer and run the program on it.

Windows User Access Control (UAC)

Microsoft Windows Vista and beyond are offered with a feature called UAC which denies administrator privileges to all users most of the time; when an application is detected which requires administrator rights is detected, a special dialogue box is used to ask for interactive confirmation. This process is called "elevation".

Penfriend should be installed by an administrator with elevated privileges. If you do this by double clicking on the *.msi file, then you will be asked to elevate your privileges during the installation process. If you install from the command line using msiexec.exe then you should do this within a command prompt or batch file set to "Run As Administrator".

Lexicons

It becomes very easy to handle individual lexicons for users, which should be done even on a stand-alone machine. There can be a directory for lexicons on the server which each user chooses their own lexicon from regardless of the computer they are using. Even better, however, is to map the user's home directory on another drive and make sure that each person has the same file name, for example U:\WRITING\MYDICT.LEX where U: is the user's home directory mount. Penfriend records in the HKEY_CURRENT_USER registry the name of the last lexicon to be used.

If your users all log in with the same Windows account, and they are starting Penfriend from the Start menu or a program shortcut, but do not wish to use the same lexicon as the previous person (each user should have their own personal lexicon), then you can switch off "Load Previous Lexicon" in the Advanced Preferences.


Keyboard target window

When you click on a letter in the on-screen keyboard window or choose a prediction from the Prediction window, Penfriend XP will simulate one or more keystrokes as if from the keyboard, and send them to the window it believes to be the appropriate active window.

Penfriend XP can sometimes get a little confused about which window should receive the keystrokes, with the result of them not appearing anywhere. As a simple rule, you should always click in your word processor document window when you start using Penfriend XP, or just after you have handled any other windows such as dialogue boxes. If there is no known focus window but you have typed any letters recently, Penfriend XP will send its simulated keystrokes to the same window as the real keystrokes were sent to. If you have clicked the mouse in a window more recently, Penfriend XP will send keystrokes to that window.

You should be careful, after moving any of the Penfriend XP windows, to click again in your word processor window. Clicking in the body of a Penfriend XP window will activate that window (this is enforced by Windows) but Penfriend XP will pass activation straight back to the last window to be active. This may cause a brief flicker of window title bars. However, clicking in the title bar of a Penfriend XP window, for example to move it, will activate that window and it will not be de-activated immediately.

You may also be interested to read about Function Key Interception.


Support

Support & Troubleshooting

Penfriend XP is normally a reliable and easily understood program, but some people may find difficulties with it. If you're having trouble with it, try the following:

  • Try again at whatever caused problems. Restart your computer and act as simply as possible.
  • Read this on-line help. Use the index and 'Search' for words that you think are related to your problem. If nothing comes up, try other words that mean the same things.
  • Look in the support section of the Penfriend web site www.penfriend.biz for more information about problems that have arisen for other users.
  • Try Penfriend XP on a different computer, if you can. Remove any other unusual software or hardware.
  • Contact Penfriend Ltd by email at support@penfriend.biz and explain your problem. Remember to mention the version of Penfriend XP you have, your computer operating system, a clear description of what didn't work as you expected, what you were doing just before the problem, and any other information or messages that appeared or are relevant.


Clicker and Penfriend XP

Using Clicker with Penfriend XP

Penfriend XP can work with other applications installed on your computer. In its 'server mode', Penfriend XP does not open any of its own windows. You can control it from another window such as a more powerful on-screen keyboard, word processor, or whatever. Doing this requires support for Penfriend XP from the other application.

Clicker, from Crick Software can work with Penfriend XP. Clicker is a powerful switch operated on-screen keyboard and word processor with symbol writing and many other powerful features. It can display word predictions from Penfriend XP in cells in its 'grids', so that clicking on these cells will insert the word into its word processor. This can happen without the user being aware of Penfriend XP except that it needs to be installed on the computer.

Clicker and Penfriend

To use the example prediction grid supplied with Clicker, go to the Examples then Keyboard and Predict. This should load Penfriend XP if is not already running, and should establish the connection between the two. Then simply type letters by clicking on the cells in the grid with your mouse, and select words from the list on the left.

If the predictions do not appear as expected, you should try quitting both applications, then loading Penfriend XP first, then Clicker. If you have an older copy of Clicker than of Penfriend XP, you may find that there are problems communicating. You can upgrade your copy of Clicker over the Internet from www.cricksoft.com or by post from Crick Software.

Designing your own Clicker Grid

You can add prediction to a Clicker grid of your own that you are designing. First, define a set of cells which will hold the predicted words. The priority order of the predicted words will be the same as the order in which you create the cells, so the first prediction cell created will show the most likely word. With each of these cells, hold down the Shift key and press the right mouse button. This will display the Cell Properties dialogue box. On the Send tab, select 'Send Text' but enter the special word {predict} (including the curly brackets but nothing before or after them). This is a special command to Clicker to fetch the words from Penfriend XP.


Function Keys

The function keys are labelled F1, F2, F3, ... F12 and should be at the top of your keyboard, above the numbers and to the right of the Escape key.

While Penfriend XP has predictions on its list, it prevents any other programs (in particular your word processor) from noticing when you press the keys used to select those predictions. Normally this means the function keys, but you may choose to select words from the ordinary number buttons. If you wish to press one of those keys to do something in your word processor, please ensure that there are no predictions from Penfriend XP visible. The easiest way of doing this is to press Space, Return or a punctuation mark. These keys cannot be part of words and so cancel the prediction. You may also press the ESCAPE key to cancel predictions for the current word, but they will be re-enabled when you begin typing another word.

To prevent Penfriend XP from interfering for a longer time, minimise the prediction window. This switches off all predictions and function key interception, and is only restored when you explicitly click to bring the prediction window back to normal size.

The function keys are intercepted to avoid confusion. They are the preferred way for Penfriend XP to see which predictions you wish to use. You can also choose predictions by clicking on the word of your choice with the mouse, or by setting the preference to Select by Number Keys or the Numeric Keypad.


Credits, Contacts, etc

Penfriend XL and Penfriend XP are Copyright (c) Penfriend Ltd 1997-2013. It was written by Roger Spooner. Thanks to Philip Whittaker for testing and advice.

The Arabic version was partially funded by MADA Assistive Technology Center, Qatar.

Penfriend Ltd can be contacted in Britain on telephone 0131 668 2000, or by fax on 0131 668 2121 or at the e-mail address support@penfriend.biz or on the World Wide Web at the address http://www.penfriend.biz This program is not shareware or freeware. If you did not pay for it, please tell us how you got it.

This product has no links to any other educational software that may have similar names except those published by Penfriend Ltd at the above address.

This help documentation was written for version 5.0. We welcome your comments on the product, and this Help documentation. Please write to us at the above address with your views, whether positive or negative.

If you would like to find out about the latest Penfreind developments and updates visit the Penfriend Blog for follow us on Twitter.


Advanced Topics

Product Activation
When installed on a computer, Penfriend XP can only be used on that computer; it is "activated" with that machine's unique identification. Until activation, the product will work with limited features. For example it will not save your changes.
Penfriend XP Portable
Instead of installation on a computer, Penfriend XP is available on a USB stick which can be used on any Windows PC without installation.
Network installation
Penfriend XP can be used on sites with many commputers connected through a network. It can also be installed remotely using scripts.
Keyboard target window
Penfriend XP intercepts key-strokes and simulates new ones, in relation to the window that has the caret focus on your computer.
Using Clicker 5
Clicker 5, from Crick Software, can work closely with Penfriend XP.
Function Keys
The function keys on your keyboard, labelled F1 .. F12 are used to choose predicted words from Penfriend XP.
Support and Troubleshooting
If you have problems using Penfriend XP, contact us for help.
Credits and contacts
Find out who made Penfriend XP, and how to contact us.


Lexicon Directories

Penfriend XP normally stores each user's lexicon of words in their 'My Documents' (Personal) folder. This is of course flexible; it could be a shared network directory, or any other location. Penfriend XP remembers the name of the last lexicon to be loaded by each user, so that it can come back to the same position where they left off last time.

For users who have never used Penfriend XP before, a default lexicon is stored in the shared application data folder. It is read-only, so when the user saves their lexicon or exits Penfriend XP, they will be asked for an alternative directory name in the 'My Documents' folder. It is strongly suggested that users should have one lexicon each, in order to allow Penfriend XP to learn each person's writing as effectively as possible.

There are several standard lexicons; ones for writers of various levels of writing skill. To find these, go to your Start Menu, then Programs, Penfriend, and then click on Lexicons. This will open the shared application data folder with all of the standard lexicons.

See Also:
- Languages